/************************************************************************ *********
 * Proiect: Obstacle Avoidance
 * Materie: Proiectarea cu microprocesoare
 * 
 * Remus Sinorchian 335CC
 *********************************************************************************/

#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>


int ADC_get()
{
	//TODO
	//setati canalul de pe care vreti sa faceti citirea
	ADMUX &= ~31;
	ADCSRA |= (1 << ADEN)| (1 << ADSC);
	//asteptati sa se termine o conversie
	loop_until_bit_is_set(ADCSRA, ADIF);
	//returnati rezultatul conversiei
	return ADC;
}

void ADC_init(void)
{
	//activez rezistenta de pull-up
	PORTA |= (1 << PA0);		
	// AVCC cu condesator pe AREF; PA0 ca input single ended; rezultat left-adjusted (8 biti de date)
	ADMUX = (1<<REFS0);
	// activeaza ADC si intreruperea de conversie. Prescaler de ceas la maximum
	ADCSRA = (1<<ADEN) | (1<<ADATE) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);

	
}


void masina_fata()		//dreapta - stanga  merg in fata
{
	while(ADC_get() >100)
		{
			PORTC |= (1 << PC6); //motorul o sa mearga in continuare in fata
			_delay_ms(6);
			
			PORTC &= ~(1 << PC7); //si nu va incerca sa dea stanga
			_delay_ms(4);
		}
}


void masina_coteste()		//stanga spate -> coteste la stanga
{
	while(ADC_get() < 100)		//cat timp am obstacol in fata, fac PWM la motor
		{
			PORTC |= (1 << PC6); 
			PORTC |= (1<<PC7);
			_delay_ms(8);
			
		}
}


int main()
{	


	

	DDRC |= (1 << PC6);		// motorul da putere in fata
	DDRC &= ~(1 << PC7);		//motorul va da putere in stanga
	

	DDRA &= ~(1 << PA0);	//PA0, pin de intrare - ADC
	
	ADC_init();
	
	while(1)
	{
		if(ADC_get() < 300)		// daca e mai mic decat 200, atunci e prea aproape si fac la stanga
		{
			
			masina_coteste();
			//PORTD |= _BV(PD7);
		}
		else
		{
			//PORTD &= ~(_BV(PD7));
			masina_fata();
		}
	}
	
	return 0;
}
